#include <stdio.h>
#include <stdlib.h>
#include <errno.h>

#include "dequeue.h"

#define MAX 10

int main(int argc, char**argv)
   {
   int i, j;
   int *ip;
   struct dequeue * deq;

   deq = dequeue_new(MAX);
   if (NULL == deq)
      {
      perror("dequeue_new");
      exit(EXIT_FAILURE);
      }

   // Fill the dequeue
   for (i=0; i < MAX; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      if (NULL == dequeue_push_top(deq, (void *) ip))
         perror("dequeue_push");
      }

   // remove 5 items
   printf("dequeue size is %zd\n", dequeue_size(deq));
   for (j=0; j < 5 && NULL != (ip = dequeue_pop_top(deq)); j++)
      {
      printf("%d\n", *ip);
      free(ip);
      }
   printf("dequeue size is %zd\n", dequeue_size(deq));

   // Overfill the dequeue
   for (i=MAX; i < 2*MAX; i++)
      {
       ip = malloc(sizeof(int));
       if (NULL == ip)
	  {
	  perror("malloc");
	  exit(EXIT_FAILURE);
	  }
      *ip = i;
      errno = 0;
      if (NULL == dequeue_push_top(deq, (void *) ip))
         {
         perror("dequeue_push_top");
         free(ip);
         }
      }

   // Empty the dequeue
   printf("dequeue size is %zd\n", dequeue_size(deq));
   while (NULL != (ip = dequeue_pop_top(deq)))
      {
      printf("%d\n", *ip);
      free(ip);
      }
   printf("dequeue size is %zd\n", dequeue_size(deq));

   // Add 3 to top
   for (i=0; i < 3; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      if (NULL == dequeue_push_top(deq, (void *) ip))
         {
         perror("dequeue_push");
         free(ip);
         }
      }
   // Add 3 to bottom
   for (;i < 6; i++)
      {
       ip = malloc(sizeof(int));
      *ip = i;
      if (NULL == dequeue_push_bottom(deq, (void *) ip))
         {
         perror("dequeue_push");
         free(ip);
         }
      }
   // empty by alternation
   printf("dequeue size is %zd\n", dequeue_size(deq));
   while (0 != dequeue_size(deq))
      {
      if ((ip = dequeue_pop_top(deq)))
         {
         printf("%d\n", *ip);
         free(ip);
         }
      if ((ip = dequeue_pop_bottom(deq)))
         {
         printf("%d\n", *ip);
         free(ip);
         }
      }
   printf("dequeue size is %zd\n", dequeue_size(deq));

   dequeue_delete(deq);

   exit(EXIT_SUCCESS);
   }
